<template name="eventPage">
	<div class="container">
		{{> event}}
	</div>
</template>

<template name="event">
	<div class="row">
		<div class="col-lg-8">
			{{#if course}}
				<div class="event-course-header" {{eventCourseHeaderAttr course}}>
					<a href="{{pathFor 'showCourse' _id=courseId}}"
					   class="event-course-header-link">
						<i class="fa-solid fa-angle-left fa-fw" aria-hidden="true"></i>
						{{i18n 'event.details.viewCourse' 'To the course overview'}}
					</a>
					<h2>
						{{course.name}}
					</h2>

					{{> courseCategories course}}
					{{> regionTag}}
					{{#each info in customFields}}
						<p>
							<strong>{{info.displayText}}</strong>: <span
								  style="white-space: pre-line;">{{info.value}}</span>
						</p>
					{{/each}}
				</div>
			{{/if}}
			<div class="event">
				{{#if editing}}
					<h3>
						{{#if _id}}
							{{i18n 'event.details.edit.edit' 'Edit event'}}
						{{else}}
							{{i18n 'event.details.edit.add' 'Create an event'}}
						{{/if}}
					</h3>
					{{> eventEdit}}
				{{else}}
					{{> eventDisplay}}
				{{/if}}
			</div>
		</div>
		{{#unless editing}}
			<div class="col-lg-4">
				{{#if isFuture}}
					<div class="page-component">
						<div class="event-page-component-header">
							<h4>
								{{i18n 'event.details.registration' 'Registration'}}
							</h4>
						</div>
					</div>
					<div class="page-component">
						<b>
							{{#unless userRegisteredForEvent}}
								{{i18n 'event.details.i-participate-no' 'Let it be known you are participating in this event. Your registration is binding.'}}
							{{else}}
								{{i18n 'event.details.i-participate-yes' 'You are now registered. Your registration is binding.'}}
							{{/unless}}
						</b>
					</div>
					<div
						 class="page-component {{#if anyDropdown}} pt-3 px-3 event-detail-register-dropdown{{/if}}">
						{{#unless userRegisteredForEvent}}
							{{#if acceptsParticipants}}
								{{#unless registerDropdown}}
									{{> buttonBeforeRegister event="js-before-register-event"}}
								{{else}}
									<p>
										{{i18n 'event.details.want-to-register' 'Do you want to reserve a seat as {USERNAME} for the event "{EVENTTITLE}" on the {DATE}? Your reservation is binding.' USERNAME=userName EVENTTITLE=title DATE=(dateFormat startLocal) attr=true}}
									</p>
									<p>
									<div class="row justify-content-between align-items-center">
										<div class="col-lg-4 d-grid">
											{{> buttonCancel event="js-register-event-cancel"}}
										</div>
										<div class="col-lg-7 d-grid">
											{{> buttonRegister event="js-register-event"}}
										</div>
									</div>
									</p>
								{{/unless}}
							{{else}}
								{{> buttonRegistrationClosed}}
							{{/if}}
						{{else}}
							{{#unless unregisterDropdown}}
								{{> buttonBeforeUnregister event="js-before-unregister-event"}}
							{{else}}
								<p>
									{{i18n 'event.details.want-to-withdraw' 'Do you want to withdraw your registration for the event "{EVENTTITLE}" on the {DATE}?' EVENTTITLE=title DATE=eventDate}}
								</p>
								<p>
								<div class="row justify-content-between align-items-center">
									<div class="col-lg-4 d-grid">
										{{> buttonCancel event="js-unregister-event-cancel"}}
									</div>
									<div class="col-lg-7 d-grid">
										{{> buttonUnregister event="js-unregister-event"}}
									</div>
								</div>
								</p>
								{{#if courseTitle}}
									<p>
										{{i18n 'event.details.youStayEnrolled' 'Note that you will stay enrolled as interested for the course "{COURSETITLE}".' COURSETITLE=courseTitle}}
									</p>
								{{/if}}
							{{/unless}}
						{{/unless}}
					</div>
				{{/if}}
				<div class="page-component">
					{{> eventParticipants}}
				</div>
				<div class="page-component">
					{{> report}}
				</div>
			</div>
		{{/unless}}
	</div>
</template>

<template name="eventDisplay">
	<div class="page-component">
		<div class="details-header event-details-header">
			<p class="h3">
				<span class="fa-regular fa-calendar-days fa-fw" aria-hidden="true"></span>
				{{weekdayFormat startLocal}} {{calendarDayShort startLocal}}
				<br><small><span class="fa-regular fa-clock fa-fw" aria-hidden="true"></span>
					{{timeFormat startLocal}} - {{timeFormat endLocal}}</small>
			</p>
		</div>
		<div class="details-body event-details-body">
			{{#unless courseId}}
				{{> regionTag}}
			{{/unless}}
			<div class="details-content">
				{{#if internal}}
					<span class="details-internal"
						  data-tooltip="{{i18n 'eventCompact.internal_event' 'Internal event'}}"></span>
				{{/if}}
				<div class="row">
					<div class="col-md-7">
						<h3>{{this.title}}</h3>

						{{> eventGroupList this}}
						<p class="event-details-description">
							{{{description}}}
						</p>
					</div>
					<div class="col-md-5">
						<div class="details-map">
							{{#if hasVenue}}
								{{> map markers=eventMarkers}}
							{{/if}}

							<div class="tag-group multiline mt-1">
								{{> venueLink}}
							</div>
							{{#if venue.address}}
								<div class="tag">
									<span class="fa-solid fa-location-dot fa-fw"
										  aria-hidden="true"></span>
									{{venue.address}}
								</div>
							{{/if}}
						</div>
					</div>
				</div>
			</div>
			{{#unless isPrivate}}
				{{> pricePolicy dismissable=true wrap='event-details-price-policy'}}
				{{> sharing}}
			{{/unless}}
		</div>
		{{#if replicating}}
			{{> eventReplication}}
		{{/if}}
		{{#if mayEdit}}
			{{#if expanded}}
				{{> eventDeleteConfirmDialog}}
			{{else}}
				{{#unless replicating}}
					<div class="actions">
						{{> buttonEdit event="js-event-edit"}}
						<button type="button" class="btn btn-edit js-show-replication">
							{{i18n 'event.details.repl_menu_btn' 'Repeat'}}
						</button>
						<a class="btn btn-edit js-download js-track-cal-download"
						   href="{{pathFor 'calEvent' this}}"
						   title="{{i18n 'event.detail.download_cal' 'Download event to my calendar' attr=true}}">
							{{i18n 'event.details.download' 'Download'}}
						</a>
						{{> buttonDelete event="js-expand"}}
					</div>
				{{/unless}}
			{{/if}}
		{{/if}}
	</div>
</template>

<template name="eventNotFound">
	{{#if currentUser}}
		<h3 class="event-notfound-text">
			{{i18n "event.not_exists" "Could not find this event. Maybe it was deleted, or never existed in the first place."}}
		</h3>
	{{else}}
		<div class="container">
			<div class="event-notfound-text">
				<h3>
					{{i18n "user.not.logged_in" "Could not find this event. Maybe you must log in!"}}
				</h3>
				<button class="js-login btn btn-save">
					<span class="fa-solid fa-right-to-bracket fa-fw"></span>
					<span>{{i18n 'event.not_exists.unlogged' 'Log in/register'}}</span>
				</button>
			</div>
		</div>
	{{/if}}
</template>

<!-- COPYPASTA WARNING
    Below are slightly modified templates from course.details.html.
    Where possible, the original translation keys have been kept.

    Most of what is in these templates could be generalized across courses and
    events. It's the pesky translation strings where I think we'll run into
    trouble when we try to unite them.
-->
<template name="eventDeleteConfirmDialog">
	<div class="event-delete-confirmation">
		<p>{{i18n 'event.reallydelete' 'Please confirm that you would like to delete this event. This might confuse other users and cannot be undone.'}}
		</p>
		<div class="form-actions">
			{{> buttonDeleteConfirm
				event="js-event-delete-confirm"
				textIdle=(i18n 'event.delete.confirm.button' 'Delete this event')
				textBusy=(i18n 'event.delete.confirm.button.busy' 'Deleting event…')
			}}
			{{> buttonCancel event="js-collapse"}}
		</div>
	</div>
</template>

<template name="eventGroupList">
	<div class="tag-group multiline">
		{{#each allGroups}}
			{{> groupName groupId=this isOrganizer=isOrganizer}}
			{{#if isOrganizer}}
				<div class="tag group-tag addon">
					<span class="fa-solid fa-bullhorn fa-fw" aria-hidden="true"
						  title="{{i18n 'grouplist.organizer.title' attr=true}}"></span>
				</div>
			{{/if}}
			{{#if tools}}
				<div class="btn-group tag-btn group-tag-btn addon align-top">
					<button type="button" class="dropdown-toggle" aria-expanded="false"
							aria-haspopup="true" data-bs-toggle="dropdown">
					</button>
					<ul class="dropdown-menu dialog-dropdown">
						<li class="dropdown-header">
							{{i18n 'grouplist.editgroup.header'}}
							<button type="button" class="btn-close"></button>
						</li>
						<li>
							<hr class="dropdown-divider">
						</li>
						{{#each tools}}
							<li class="dialog-dropdown-btn">{{> toolTemplate}}</li>
						{{/each}}
					</ul>
				</div>
			{{/if}}
		{{/each}}
		{{> eventGroupAdd}}
	</div>
</template>

<template name="eventGroupAdd">
	{{#if groupsToAdd}}
		<div class="btn-group tag-btn group-tag-btn align-top">
			<button type="button" class="dropdown-toggle" aria-expanded="false" aria-haspopup="true"
					data-bs-toggle="dropdown">
				<span class="fa-solid fa-plus fa-fw" aria-hidden="true"></span>
				<span>{{i18n 'event.group.addText' 'link a group'}}</span>
			</button>
			<ul class="dropdown-menu dialog-dropdown">
				<li class="dropdown-header">
					{{i18n 'grouplist.addgroups.header'}}
					<button type="button" class="btn-close"></button>
				</li>
				<li>
					<hr class="dropdown-divider">
				</li>
				{{#each groupsToAdd}}
					<li>
						<button class="btn btn-link js-add-group" type="button" value="{{this}}">
							{{name this}}
						</button>
					</li>
				{{/each}}
				<li class="dialog-dropdown-btn">
					<a href="{{pathFor 'groupDetails' _id='create'}}" class="btn btn-add">
						{{i18n 'profile.createNewGroup.button'}}
					</a>
				</li>
			</ul>
		</div>
	{{/if}}
</template>

<template name="eventGroupRemove">
	{{#if expanded}}
		<div class="group-tool-dialog danger">
			{{i18n 'event.group.confirmRemoveText' 'Remove the "{NAME}" group from this event?' NAME=(name groupId)}}
			<button type="button" class="btn btn-remove js-remove">
				{{i18n 'course.group.confirmRemoveButton'}}
			</button>
		</div>
	{{else}}
		<a href="#" class="js-expand btn btn-remove">
			<span class="fa-solid fa-xmark fa-fw" aria-hidden="true"></span>
			{{i18n 'course.group.remove'}}
		</a>
	{{/if}}
</template>

<template name="eventGroupMakeOrganizer">
	{{#if expanded}}
		<div class="group-tool-dialog add">
			{{i18n 'course.group.confirmOrgText' NAME=(name groupId)}}
			{{i18n 'event.group.confirmOrgNotes' "All members of this group will be able to edit this event."}}
			<button type="button" class="btn btn-add js-makeOrganizer">
				{{i18n 'course.group.confimOrgButton'}}
			</button>
		</div>
	{{else}}
		<a href="#" class="js-expand btn btn-add">
			<span class="fa-solid fa-bullhorn fa-fw" aria-hidden="true"></span>
			{{i18n 'course.group.addOrgText'}}
		</a>
	{{/if}}
</template>

<template name="eventGroupRemoveOrganizer">
	{{#if expanded}}
		<div class="group-tool-dialog danger">
			{{i18n 'course.group.confirmRemoveOrgText' NAME=(name groupId)}}
			<button type="button" class="btn btn-remove js-removeOrganizer">
				{{i18n 'course.group.confimRemoveOrgButton'}}
			</button>
		</div>
	{{else}}
		<a href="#" class="js-expand btn btn-remove">
			<span class="fa-solid fa-xmark fa-fw" aria-hidden="true"></span>
			{{i18n 'course.group.removeOrgText' NAME=(name groupId)}}
		</a>
	{{/if}}
</template>

<template name="buttonBeforeRegister">
	<button type="button" class="btn btn-add btn-event {{event}}" {{disabledIfBusy}}>
		{{i18n 'event.details.reserve-a-seat' 'Reserve a seat'}}
	</button>
</template>

<template name="buttonRegister">
	<button type="button" class="btn btn-add btn-event text-center {{event}}" {{disabledIfBusy}}>
		{{#if busy 'registering'}}
			<span class="fa-solid fa-circle-notch fa-spin fa-fw" aria-hidden="true"></span>
			{{i18n '_button.registering' 'Registering…'}}
		{{else}}
			{{i18n 'event.details.register-register' 'Register'}}
		{{/if}}
	</button>
</template>

<template name="buttonRegistrationClosed">
	<button type="button" class="btn btn-warning btn-event {{event}}" {{disabledIfBusy}}>
		{{#if busy 'registering'}}
			<span class="fa-solid fa-circle-notch fa-spin fa-fw" aria-hidden="true"></span>
			{{i18n '_button.addingYouToWaitingQueue' 'Adding you to waiting queue…'}}
		{{else}}
			{{i18n 'event.details.isFullyBooked' 'The event is fully booked'}}
		{{/if}}
	</button>
</template>

<template name="buttonBeforeUnregister">
	<button type="button" class="btn btn-add btn-event {{event}}" {{disabledIfBusy}}>
		{{i18n 'event.details.withdraw-registration' 'Withdraw my registration'}}
	</button>
</template>

<template name="buttonUnregister">
	<button type="button" class="btn btn-danger btn-event text-center {{event}}" {{disabledIfBusy}}>
		{{#if busy 'unregistering'}}
			<span class="fa-solid fa-circle-notch fa-spin fa-fw" aria-hidden="true"></span>
			{{i18n '_button.unregistering' 'Unregistering…'}}
		{{else}}
			{{i18n 'event.details.unregister-withdraw' 'Withdraw'}}
		{{/if}}
	</button>
</template>
